"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Logger_1 = require("./Logger");
const NpmLogReporter_1 = require("./reporters/NpmLogReporter");
const LogLevel_1 = require("./LogLevel");
const JsonReporter_1 = require("./reporters/JsonReporter");
function initReporters(config) {
    // Initialize logger
    const logLevel = config.verbose ? LogLevel_1.LogLevel.verbose : LogLevel_1.LogLevel.info;
    const reporters = [
        config.reporter === "json"
            ? new JsonReporter_1.JsonReporter({ logLevel })
            : new NpmLogReporter_1.NpmLogReporter({
                logLevel,
                grouped: config.grouped,
            }),
    ];
    Logger_1.Logger.reporters = reporters;
    return reporters;
}
exports.initReporters = initReporters;
